package com.bjsxt.plane;

import java.awt.*;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

/**
 * 游戏窗口
 */
public class MyGameFrame extends Frame {



    Image planeImg = GameUtil.getImage("plane.png");
    Image bg = GameUtil.getImage("bg.jpg");


    Plane p1 = new Plane(planeImg,100,100,7);

    boolean left,right,up,down;  // 飞机的方向控制

    @Override
    public void paint(Graphics g) {   //当做是一只画笔

        g.drawImage(bg,0,0,500,500,null);

      p1.drawMyself(g);

        if(left){
            p1.x -= p1.Speed;
        }
        if (right){
            p1.x += p1.Speed;
        }
        if (up){
            p1.y -= p1.Speed;
        }
        if (down){
            p1.y += p1.Speed;
        }

    }

    //初始化窗口
    public void launchFrame(){
        this.setTitle("飞机大战-尚学堂");
        setVisible(true);   // 窗口是否可见

        setSize(Constant.GAME_WIDTH, Constant.GAME_HEIGHT);   //窗口大小

        setLocation(400,400);       //窗口打开位置

        //增加关闭窗口的动作
        this.addWindowListener(new WindowAdapter() {
            @Override
            public void windowClosing(WindowEvent e) {
                System.exit(0);   //正常退出程序
            }
        });

        new paintThread().start();  //启动重画窗口的线程
        this.addKeyListener(new KeyMonitor());  //启动键盘监听
    }


    /**
     * 定义了一个重画窗口的线程类。
     * 定义成内部类是为了方便直接使用窗口的相关方法
     */
    class paintThread extends Thread{
        @Override
        public void run() {
            while (true){
                repaint();      //内部类可以直接使用外部类的成员！

                try{
                    Thread.sleep(50);     //1s=1000ms画20次(20*50=1000)
                }catch (InterruptedException e){
                    e.printStackTrace();
                }
            }
        }
    }


    //内部类，实现键盘的监听处理
    class KeyMonitor extends KeyAdapter {

        @Override
        public void keyPressed(KeyEvent e) {
          System.out.println("按下:"+e.getKeyCode());
           /* if (e.getKeyCode()==KeyEvent.VK_LEFT);{
                left = true;
            }
            if (e.getKeyCode()==KeyEvent.VK_RIGHT);{
                right = true;
            }*/

            switch (e.getKeyCode()){
                case KeyEvent.VK_LEFT:
                    left = true;
                    break;
                case KeyEvent.VK_RIGHT:
                    right = true;
                    break;
                case KeyEvent.VK_UP:
                    up = true;
                    break;
                case KeyEvent.VK_DOWN:
                    down = true;
                    break;

            }

        }

        @Override
        public void keyReleased(KeyEvent e) {
           System.out.println("抬起:"+e.getKeyCode());
            switch (e.getKeyCode()){
                case KeyEvent.VK_LEFT:
                    left = false;
                    break;
                case KeyEvent.VK_RIGHT:
                    right = false;
                    break;
                case KeyEvent.VK_UP:
                    up = false;
                    break;
                case KeyEvent.VK_DOWN:
                    down = false;
                    break;
            }


        }
    }





    private Image offScreenImage = null;

   public void update(Graphics g){
       if (offScreenImage == null);
       offScreenImage = this.createImage(Constant.GAME_WIDTH, Constant.GAME_HEIGHT);//这是游戏窗口的亮度和高度

       Graphics gOff = offScreenImage.getGraphics();
       paint(gOff);
       g.drawImage(offScreenImage,0,0,null);
    }


    public static void main(String[] args) {
        MyGameFrame gameFrame = new MyGameFrame();
        gameFrame.launchFrame();
    }
}
